unit trscn_fm;

{This program is a test of the TreeScanner component.  By setting the
InitialDirectory of the TreeScanner component to a CDROM, the size
and number of files on that CD, excluding those in certain directories
may be ascertained}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, TreeScan;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    btnGo: TButton;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    lblFiles: TLabel;
    lblBytes: TLabel;
    Label2: TLabel;
    TreeScanner1: TTreeScanner;
    procedure btnGoClick(Sender: TObject);
    procedure TreeScanner1FileFound(Sender: TObject);
    procedure TreeScanner1DirectoryFound(Sender: TObject);
    procedure TreeScanner1DirectoryDone(Sender: TObject);
  private
    { Private declarations }
    total_files: integer;
    total_bytes: integer;
    ignore: boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnGoClick(Sender: TObject);
begin
  if TreeScanner1.SearchInProgress then
    begin
    TreeScanner1.Continue := False;
    Exit;
    end;

  btnGo.Caption := 'Stop';
  lblFiles.Caption := '';
  total_files := 0;
  total_bytes := 0;
  Screen.Cursor := crHourGlass;
  TreeScanner1.ScanTree;
  Screen.Cursor := crDefault;
  btnGo.Caption := 'Search';
end;

procedure TForm1.TreeScanner1FileFound(Sender: TObject);
var
  f: TSearchRec;
begin
  if ignore then Exit;
  ListBox1.Items.Add (TreeScanner1.FileFound);
  Inc (total_files);
  if FindFirst (TreeScanner1.FileFound, faAnyfile, f) = 0
    then Inc (total_bytes, f.Size);
  FindClose (f);
end;

procedure TForm1.TreeScanner1DirectoryFound(Sender: TObject);
// we will skip directories whose name contains one of the strings below
const
  num_ignores = 3;
  ignores: array [1..num_ignores] of string =
    ('\ALPHA\', '\MIPS\', '\PPC\');
var
  i: integer;
begin
  ignore := False;
  for i := 1 to num_ignores do
    ignore := ignore or
              (Pos (ignores [i], UpperCase (TreeScanner1.FileFound)) <> 0);
  if ignore then Exit;
  ListBox1.Items.BeginUpdate;
  ListBox1.Items.Add ('----' + TreeScanner1.FileFound + '----');
end;

procedure TForm1.TreeScanner1DirectoryDone(Sender: TObject);
begin
  ListBox1.Items.EndUpdate;
  lblFiles.Caption := Format ('%.0n', [total_files + 0.0]);
  lblBytes.Caption := Format ('%.0n', [total_bytes + 0.0]);
end;

end.

